#!/bin/bash

CLN_REGISTER_SERVER="https://cln.cloudlinux.com/cln/api/els/server/register"
CLN_UNREGISTER_SERVER="https://cln.cloudlinux.com/cln/api/els/server/unregister"
LICENSE=""
HOSTNAME=$(hostname)
AUTH_CONF_PATH="/etc/apt/auth.conf.d/alt-python-els.conf"

ALT_COMMON_PACKAGE_URI="https://repo.alt.tuxcare.com/alt-common/alt-common-release-install.amd64.deb"
ELS_PYTHON_PACKAGE_URI="https://repo.alt.tuxcare.com/alt-python-els/els-python-release-install.amd64.deb"

# Temporary files
ALT_COMMON_TEMP_DEB=""
ELS_PYTHON_TEMP_DEB=""

exec 3>&1

cleanup() {
    if [[ -f "$ELS_PYTHON_TEMP_DEB" ]]; then
        rm -f "$ELS_PYTHON_TEMP_DEB"
    fi

    if [[ -f "$ALT_COMMON_TEMP_DEB" ]]; then
        rm -f "$ALT_COMMON_TEMP_DEB"
    fi

    exec 3>&-
}

trap cleanup EXIT

log() {
    printf "%s\\n" "$1" 1>&3
}

show_usage() {
    echo 'Usage: install-els-alt-python-deb-repo.sh [OPTION]...'
    echo ''
    echo '  -l, --license-key   User license key'
    echo '  -f, --force         Force re-register if ELS is already installed'
    echo '  -d, --delete        Delete ELS from server'
    echo '  -h, --help          Show this message and exit'
}

do_opts() {
    if [ $# -eq 0 ]; then
        log "$(show_usage)"
        exit 1
    fi
    while [ $# -gt 0 ]; do
        key="$1"
        case $key in
            -h|--help)
                log "$(show_usage)"
                exit 0
                ;;
            -l|--license-key)
                if [[ -z "$2" || "$2" == -* ]]; then
                    log "Error: --license-key requires an argument"
                    log "$(show_usage)"
                    exit 1
                fi
                LICENSE="$2"
                shift
                ;;
            -f|--force)
                FORCE=true
                ;;
            -d|--delete)
                DELETE=true
                ;;
            -*|--*)
                log "Unknown option: $key"
                log "$(show_usage)"
                exit 1
                ;;
        esac
        shift
    done

    if [ -z "$LICENSE" ] && [ "$DELETE" != "true" ]; then
        log "Required argument not provided: --license-key"
        log "$(show_usage)"
        exit 1
    fi
}

get_distro_name() {
    local os_release_path="/etc/os-release"
    log "Get OS info... "
    if [ ! -f "$os_release_path" ]; then
        log "Error (Could not determine OS: $os_release_path does not exist)"
        return 0
    fi
    . "$os_release_path"
    if [ -z "$ID" ]; then
        log "Error (Could not determine OS: ID not found in $os_release_path)"
        return 1
    fi
    echo "$ID"
    return 0
}

alt_python_els_installed() {
    log "Checking if els-python-release is already installed... "
    if dpkg -l els-python-release >/dev/null 2>&1; then
        log "els-python-release package is already installed."
        return 0
    fi
    log "els-python-release package is not installed"
    return 1
}

extract_token() {
    token=$(sed -n 's/^login \([^[:space:]]*\).*/\1/p' "$AUTH_CONF_PATH")

    if [[ -z "$token" || "$token" != *SERVER* ]]; then
        log "Couldn't extract token from $AUTH_CONF_PATH"
        return 1
    fi

    echo "$token"
    return 0
}


unregister_token() {
    if ! token=$(extract_token); then
        return 1
    fi

    response=$(curl -i -s -X POST "${CLN_UNREGISTER_SERVER}?token=${token}")
    curl_exit_code=$?

    if [ $curl_exit_code -ne 0 ]; then
        log "ERROR: Failed to connect to unregister server (curl exited with status: $curl_exit_code)"
        return 1
    fi

    if ! echo "$response" | grep -qi '^HTTP/[0-9.].*200.*OK'; then
        if [[ -z "$response" ]]; then
            log "DELETE: elstoken wasn't found. Server is not registered"
        else
            log "Got incorrect status from CLN: $response"
        fi
        return 1
    fi

    log "Unregistered successfully"
    return 0
}

remove_alt_python_els() {
    # This will remove repo configuration
    log "Purging els-python-release package... "
    if apt-get purge -yq els-python-release 1>&3; then
        log "Ok"
    else
        log "Error (Could not purge els-python-release package)"
        return 1
    fi

    log "Removing authentication configuration file... "
    if rm -f "$AUTH_CONF_PATH" 1>&3; then
        log "Ok"
    else
        log "Error (Could not remove auth configuration file: $AUTH_CONF_PATH)"
        return 1
    fi

    log "Alt python ELS deleted successfully"
    return 0
}

get_auth_token() {
    log "Request repository token for this server... "
    local data="{\"key\": \"$3\", \"host_name\": \"$2\"}"
    local ret
    ret=$(curl -s -X POST -H "Content-Type: application/json" -H "Accept: application/json" -d "$data" "$1")
    if [ $? -ne 0 ]; then
        log "Error (Curl command failed)"
        return 1
    fi
    local token
    token=$(echo "$ret" | grep -oP '"token":"\K[^"]*')
    if [ -n "$token" ]; then
        log "Ok"
        echo "$token"
        return 0
    fi
    log "Error (No token was returned from CLN)"
    return 1
}

install_alt_common_release() {
    log "Checking if alt-common-release is already installed... "
    if dpkg -l alt-common-release >/dev/null 2>&1; then
        log "alt-common-release package is already installed."
        return 0
    fi
    log "Installing alt-common-release..."

    ALT_COMMON_TEMP_DEB=$(mktemp /tmp/alt-common-releaseXXXXXX.deb)

    if ! curl -fsSL -o "$ALT_COMMON_TEMP_DEB" "$ALT_COMMON_PACKAGE_URI"; then
        log "Error: Couldn't download alt-common-release.deb"
        return 1
    fi

    if ! dpkg -i "$ALT_COMMON_TEMP_DEB"; then
        log "Error: Couldn't install alt-common-release"
        return 3
    fi

    return 0
}

install_alt_python_release() {
    if ! install_alt_common_release; then
        return 2
    fi
    log "Installing els-python-release..."

    ELS_PYTHON_TEMP_DEB=$(mktemp /tmp/els-python-release-XXXXXX.deb)

    if ! curl -fsSL -o "$ELS_PYTHON_TEMP_DEB" "$ELS_PYTHON_PACKAGE_URI"; then
        log "Error: Couldn't download els-python-release.deb"
        return 1
    fi

    if ! dpkg -i "$ELS_PYTHON_TEMP_DEB"; then
        log "Error: Couldn't install els-python-release"
        return 3
    fi
}

check_superuser_privileges() {
    log "Checking for superuser privileges..."
    if [ "$(id -u)" -ne 0 ]; then
        log "Error: This script must be run with superuser privileges"
        return 1
    fi
    log "Superuser privileges confirmed"
    return 0
}

check_system_compatibility() {
    log "Checking system compatibility..."

    distro=$(get_distro_name)
    if [ "$distro" != "debian" ] && [ "$distro" != "ubuntu" ]; then
        log "Detected unsupported distro: $distro"
        return 11
    fi

    if ! command -v curl &> /dev/null; then
        log "Error: curl is required but not installed"
        return 1
    fi

    log "System compatibility check passed"
}

main() {
    do_opts "$@"

    if ! check_superuser_privileges; then
        return 14
    fi

    if ! check_system_compatibility; then
        return 1
    fi

    if [ "$DELETE" = "true" ];  then
        if alt_python_els_installed; then
            if ! unregister_token; then
                log "Couldn't deactivate account"
                return 12
            fi
            remove_alt_python_els
        else
            log "ELS is not installed"
        fi
        return 0
    fi

    if alt_python_els_installed; then
        if [ "$FORCE" = "true" ]; then
            unregister_token
            remove_alt_python_els
        else
            log "This server has installed ELS repo and token"
            log "For re-registration license run script with --force"
            return 2
        fi
    fi

    log "Registering in CLN..."
    local token
    token=$(get_auth_token "$CLN_REGISTER_SERVER" "$HOSTNAME" "$LICENSE")
    if [ $? -ne 0 ]; then
        return 3
    fi

    if ! echo -e "machine repo.alt.tuxcare.com/alt-python-els/\nlogin $token\npassword" > "$AUTH_CONF_PATH"; then
        log "Error (Could not write to $AUTH_CONF_PATH)"
        return 10
    fi

    log "Applying repository token for this server..."
    if ! install_alt_python_release; then
        return 9
    fi

    log "Updating cache..."
    if ! apt-get -yq update 1>&3; then
        log "Error (Could not update repository cache)"
        return 6
    fi

    log "ELS for alt python installed successfully"
}

main "$@"
